<?php
/**
 * @author Daniel Knudsen <d.knudsen@spawntree.de>
 * @date 12.12.23
 */


namespace App\Tests\Functional;

use App\Factory\ContactFactory;
use App\Factory\MediaObjectLogoFactory;
use App\Factory\MediaObjectContactFactory;
use App\Factory\MediaObjectUserFactory;
use App\Factory\PartnerFactory;
use App\Factory\PostingFactory;
use App\Factory\ProductFactory;
use App\Factory\SaleFactory;
use App\Factory\UserFactory;
use Lexik\Bundle\JWTAuthenticationBundle\Services\JWTTokenManagerInterface;
use Symfony\Bundle\FrameworkBundle\Test\KernelTestCase;
use Zenstruck\Browser\Test\HasBrowser;
use Zenstruck\Foundry\Test\Factories;
use Zenstruck\Foundry\Test\ResetDatabase;

class PostingResourceTest extends KernelTestCase
{
    use HasBrowser;
    use ResetDatabase;
    use Factories;

    private JWTTokenManagerInterface $JWTManager;

    protected function setUp(): void
    {
        parent::setUp();
        $this->JWTManager = self::getContainer()->get('lexik_jwt_authentication.jwt_manager');
    }

    public function testPostPosting(): void
    {
        $user = UserFactory::createOne(
            [
                'email' => 'peter@test.de',
                'firstName' => 'Peter',
                'lastName' => 'Test',
                'password' => 'test',
            ]
        );

        $partner = PartnerFactory::createOne();
        $product = ProductFactory::createOne();
        $contact = ContactFactory::createOne();
        SaleFactory::createOne();
        PostingFactory::createOne();

        $token = $this->JWTManager->create($user->object());

        $this->browser()
            ->post('/api/posts' , [
                'json' => [
                    'headline' => 'hello',
                    'message' => 'world',
                    'partner' => '/api/partners/' . $partner->getId(),
                    'contact' => '/api/contacts/' . $contact->getId(),
                    'product' => '/api/products/' . $product->getId(),
                ],
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ]
            ])
            ->assertSuccessful()
        ;

        $this->browser()
            ->get('/api/posts', [
                    'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                ],
            ])
            ->assertSuccessful()
            ->assertJsonMatches('"hydra:totalItems"', 2)
        ;
    }
}